//+------------------------------------------------------------------+
//|                                                          R1R2 v1 |
//|                                                   Amritendu Maji |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Amritendu Maji"
#property link      "http://www.tradingmarkets.com/.site/stocks/commentary/editorial/The-Improved-R2-Strategy.cfm"


extern double Lots=0.1;
extern double MaxLots=10;
extern int LotDigits=2;
extern int Slippage=3;

extern string EAName = "R1R2";
extern int MagicNumber = 55141;
extern int MaxTrades = 1;

extern int RSIPeriod = 3;
extern int MAPeriod = 200;
extern int MAMethod = 0;
extern double RSIBuy = 65;
extern double RSISell = 75;
extern double RSIShort = 35;
extern double RSICover = 25;

extern int StopPips = 0;

extern bool MM = false; //Use Money Management or not
extern double RiskPercent = 2; //% of margin available per trade

datetime timeprev=0;

double price, prcopp;
datetime expiration;
double RSI1, RSI2, RSI3, MA1, MA2, MA3;
double Profit, Spread;
double Cl1, Cl2, Cl3; 
double iLots;
bool Buy=false, Sell=false, Cover=false, Short=false;
 
int init()
{
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{

 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];

 { 
 
  Cl1 = iClose(Symbol(),0,1); 
  Cl2 = iClose(Symbol(),0,2); 
  Cl3 = iClose(Symbol(),0,3); 

  RSI1 = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE, 1);
  RSI2 = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE, 2);
  RSI3 = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE, 3);
  
  MA1 = iMA(Symbol(),0,MAPeriod,0,MAMethod,PRICE_CLOSE,1);
  MA2 = iMA(Symbol(),0,MAPeriod,0,MAMethod,PRICE_CLOSE,2);
  MA3 = iMA(Symbol(),0,MAPeriod,0,MAMethod,PRICE_CLOSE,3);
  
  expiration = 0; 
  
  Spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;

  Profit = 0;
  
  if(MM==true) 
   iLots = LotSize(StopPips);
  else
   iLots = Lots;
      
  Buy = Cl1>MA1 && Cl2>MA2 && Cl3>MA3 && RSI3<RSIBuy && RSI2<RSI3 && RSI1<RSI2;
  Sell = RSI2<RSISell && RSI1>RSISell;
  if(CountLongs(MagicNumber)>0 && Sell) {CloseLongs(MagicNumber); Sell=false;}

  Short = Cl1<MA1 && Cl2<MA2 && Cl3<MA3 && RSI3>RSIShort && RSI2>RSI3 && RSI1>RSI2;
  Cover = RSI2>RSICover && RSI1<RSICover;
  if(CountShorts(MagicNumber)>0 && Cover) {CloseShorts(MagicNumber); Cover=false;}
  


  if (Buy && CountLongs(MagicNumber)<MaxTrades)
  {
   price=Ask;
   prcopp=Bid;
   OpenPendingOrder(OP_BUY,iLots,price,Slippage,prcopp,StopPips,Profit,EAName,MagicNumber,expiration,Green);
   Buy = false;
  }
  
  if (Short && CountShorts(MagicNumber)<MaxTrades)
  {
   price=Bid;
   prcopp=Ask;
   OpenPendingOrder(OP_SELL,iLots,price,Slippage,prcopp,StopPips,Profit,EAName,MagicNumber,expiration,Red);
   Sell = false;
  } 
  


 }//Open Pending

 
 return(0);
}

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShort(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}

void CloseLongs(int MagicNumber1)
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber1)
  {
   if(OrderType()==OP_BUY)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
  }
 }
}

void CloseShorts(int MagicNumber1)
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber1)
  {
   if(OrderType()==OP_SELL)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Red);
  }
 }
}

int OpenPendingOrder(int pType,double pLots,double pLevel,int sp, double pr, int sl, int tp,string pComment,int pMagic,datetime pExpiration,color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  switch (pType)
  {
      case OP_BUY:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            RefreshRates();
            ticket=OrderSend(Symbol(),OP_BUY,pLots,Ask,sp,StopLong(Bid,sl),TakeLong(Ask,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYLIMIT,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELL:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            RefreshRates();
            ticket=OrderSend(Symbol(),OP_SELL,pLots,Bid,sp,StopShort(Ask,sl),TakeShort(Bid,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLSTOP,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
  } 
  
  return(ticket);
}  

double LotSize(double StopLossInPips)
{ 
 int Leverage =  AccountLeverage(); 
 double PipValue = MarketInfo(Symbol(), MODE_TICKVALUE);
 double lotMM;

 lotMM = NormalizeDouble((AccountFreeMargin()*RiskPercent/100)/(StopLossInPips*PipValue),LotDigits);
   
   if (lotMM < Lots) lotMM = Lots;
   if  (lotMM > MaxLots) lotMM = MaxLots;
   return (lotMM);
} 



int CountLongs(int MagicNumber2)
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol())
   continue;
   
  if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber2)
  if((OrderType()==OP_BUY) || (OrderType()==OP_BUYSTOP))
   count++;
 }//for
 return(count);
}

int CountShorts(int MagicNumber2)
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol())
   continue;
   
  if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber2)
  if((OrderType()==OP_SELL) || (OrderType()==OP_SELLSTOP))
   count++;
 }//for
 return(count);
}



